Package org.eclipse.rdf4j.sparqlbuilder.constraint

## Class Expression<T extends Expression<T>>

- java.lang.Object
- - org.eclipse.rdf4j.sparqlbuilder.core.QueryElementCollection<T>
  - - org.eclipse.rdf4j.sparqlbuilder.core.StandardQueryElementCollection<Operand>
    - - org.eclipse.rdf4j.sparqlbuilder.constraint.Expression<T>

- Type Parameters:
    `T` - the type of Expression (ie, Function or Operation). Used to support fluency
  All Implemented Interfaces:
    `Operand`, `Assignable`, `Groupable`, `Orderable`, `QueryElement`
  Direct Known Subclasses:
    `Aggregate`, `CustomFunction`, `In`, `NotIn`

      public abstract class Expression<T extends Expression<T>>
      extends StandardQueryElementCollection<Operand>
      implements Operand, Orderable, Groupable, Assignable

  A SPARQL expression. Used by filters, having clauses, order and group by clauses, assignments, and as arguments to other expressions.
  See Also:
    SPARQL Filters, SPARQL HAVING, SPARQL ORDER BY, SPARQL GROUP BY, SPARQL Assignments

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected SparqlOperator` | `operator` |

    - ### Fields inherited from class org.eclipse.rdf4j.sparqlbuilder.core.QueryElementCollection

      `elements`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `T` | `parenthesize()` | Indicate that this expression should be wrapped in parentheses when converted to a query string
    `T` | `parenthesize​(boolean parenthesize)` | Indicate if this expression should be wrapped in parentheses when converted to a query string

    - ### Methods inherited from class org.eclipse.rdf4j.sparqlbuilder.core.StandardQueryElementCollection

      `getQueryString, printBodyIfEmpty, printNameIfEmpty, resetWrapperMethod, setOperatorName, setOperatorName, setWrapperMethod`

    - ### Methods inherited from class org.eclipse.rdf4j.sparqlbuilder.core.QueryElementCollection

      `addElements, addElements, isEmpty`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.eclipse.rdf4j.sparqlbuilder.core.Assignable

      `as`

    - ### Methods inherited from interface org.eclipse.rdf4j.sparqlbuilder.core.Orderable

      `asc, desc`

    - ### Methods inherited from interface org.eclipse.rdf4j.sparqlbuilder.core.QueryElement

      `getQueryString`

- - ### Field Detail

    - #### operator

          protected SparqlOperator operator

  - ### Method Detail

    - #### parenthesize

          public T parenthesize()

      Indicate that this expression should be wrapped in parentheses when converted to a query string
      Returns:
        this

    - #### parenthesize

          public T parenthesize​(boolean parenthesize)

      Indicate if this expression should be wrapped in parentheses when converted to a query string
      Parameters:
        `parenthesize` -
      Returns:
        this